//functions are faster than macros
//functions can be inserted into the macros menu
//Proc procedures can use global wave names directly
//proc are macros that do not show up in the menu by default


//***********************************************************************************************************************
//	Proc GetWaveStatsInCurrentFolder(t1,t2)
//		This procedure gets the wave stats over a particular range of a wave.
function selectamplitudes()

	variable /g samplerate
	variable tempsamplerate = samplerate
	prompt tempsamplerate,"Sample Rate"

	string /g amplitudetype //stores the selected amplitude type
	string tempamplitudetype = amplitudetype
	Prompt tempamplitudetype,"Amplitude Type", popup, "mean crossing max;mean crossing min;mean crossing range"
	

	String /g wname //stores the selected wave name
	string tempwname = wname
	Prompt tempwname,"Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	variable V_Flag
	DoPrompt "Amplitude Selection",tempamplitudetype,tempwname,tempsamplerate //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif

	amplitudetype = tempamplitudetype
	wname = tempwname
	samplerate = tempsamplerate


	wave waveref = $wname


	variable scans = numpnts(waveref) //get the number of scans from the selected wave
	variable /g wmean
	wmean = mean(waveref,0,scans-1) //get the mean of the selected wave
	
	string amplitudeswave = "amplitudes"
	make /O/N=(scans) $amplitudeswave
	wave amplitudes = $amplitudeswave
	
	string amplitudeindexeswave = "amplitudeindexes"
	make /O/N=(scans) $amplitudeindexeswave
	wave amplitudeindexes = $amplitudeindexeswave

	string meancrossingswave = "meancrossings"
	make /O/N=(scans) $meancrossingswave
	wave meancrossings = $meancrossingswave

	string meancrossingindexeswave = "meancrossingindexes"
	make /O/N=(scans) $meancrossingindexeswave
	variable numberofmeancrossings = 0
	wave meancrossingindexes = $meancrossingindexeswave
	
	variable i
	for(i=2;i<scans-2;i=i+1)
		if((waveref[i-2] > wmean && waveref[i-1] > wmean && waveref[i+1] < wmean && waveref[i+2] < wmean) || (waveref[i-2] < wmean && waveref[i-1] < wmean && waveref[i+1] > wmean && waveref[i+2] > wmean))
			meancrossings[numberofmeancrossings] = waveref[i]
			meancrossingindexes[numberofmeancrossings] = i
			numberofmeancrossings = numberofmeancrossings + 1
			i=i+4
		endif
	endfor
	
	redimension /N=(numberofmeancrossings) meancrossings
	redimension /N=(numberofmeancrossings) meancrossingindexes

	variable amplitude
	variable amplitudeindex
	variable maximum
	variable maximumindex
	variable minimum
	variable minimumindex
	variable range
	variable rangeindex
	variable numberofamplitudes = 0
	variable mc
	
	for(mc=1; mc < numberofmeancrossings; mc=mc+2)
		maximum = waveref[meancrossingindexes[mc-1]]
		minimum = waveref[meancrossingindexes[mc-1]]
		for(i=meancrossingindexes[mc-1];i < meancrossingindexes[mc+1]; i=i+1)
			if(waveref[i] > maximum)
				maximum = waveref[i]
				maximumindex = i
			endif
			if(waveref[i] < minimum)
				minimum = waveref[i]
				minimumindex = i
			endif
		endfor
		range = maximum-minimum
		rangeindex = (maximumindex+minimumindex)/2
		if(stringmatch(amplitudetype,"mean crossing max"))
			amplitude=maximum
			amplitudeindex=maximumindex
		elseif(stringmatch(amplitudetype,"mean crossing min"))
			amplitude=minimum
			amplitudeindex=minimumindex
		elseif(stringmatch(amplitudetype,"mean crossing range"))
			amplitude=range
			amplitudeindex=rangeindex
		endif
		
		amplitudes[numberofamplitudes]=amplitude
		amplitudeindexes[numberofamplitudes]=amplitudeindex/samplerate
		numberofamplitudes=numberofamplitudes+1
	endfor
	meancrossingindexes = meancrossingindexes/samplerate
	redimension /N=(numberofamplitudes) amplitudes,amplitudeindexes
	print numberofamplitudes


	//display results
	display amplitudes vs amplitudeindexes as "Selected Amplitudes"
	appendtograph $wname
	ModifyGraph rgb($wname)=(0,12800,52224)
	ModifyGraph mode(amplitudes)=3
	Legend/C/N=text0/A=MC
	Label left "ln(ln(1/(1-P))"
	Label bottom "ln(x)"
	TextBox/C/N=text1/A=MC "Amplitude Statistics"
	appendtext "numamplitudes: " + num2str(numpnts(amplitudes))




end //select amplitudes






