//functions are faster than macros
//functions can be inserted into the macros menu
//Proc procedures can use global wave names directly
//proc are macros that do not show up in the menu by default











function fftfilter()

	variable /g samplerate
	variable tempsamplerate = samplerate
	prompt tempsamplerate,"Sample Rate"
	
	variable /g cutofffrequency
	variable tempcutofffrequency = cutofffrequency
	prompt tempcutofffrequency,"Cutoff Frequency"

	string /g filtertype //stores the selected filter type
	string tempfiltertype = filtertype
	Prompt tempfiltertype,"Amplitude Type", popup, "lowpass;highpass"
	
	String /g wname //stores the selected wave name
	string tempwname = wname
	Prompt tempwname,"Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	
	//prompt the user for inputs
	variable V_Flag
	DoPrompt "Filter Selection",tempfiltertype,tempwname,tempsamplerate,tempcutofffrequency //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif

	filtertype = tempfiltertype
	wname = tempwname
	samplerate = tempsamplerate
	cutofffrequency = tempcutofffrequency

	//subtract the mean of the input data file
	variable wmean = mean($wname)
	wave wwave = $wname
	wwave = wwave - wmean
	
	//determine the next largest power of 2 data points and pad the data
	variable originaldatasize = numpnts($wname)
	print originaldatasize
	variable lowerpowerof2 = originaldatasize / 2
	variable nextpowerof2 = 2
	do	
		lowerpowerof2 = lowerpowerof2 / 2
		nextpowerof2 = nextpowerof2 + 1		
	while(lowerpowerof2 > 2)
	print nextpowerof2
	variable paddeddatasize = 2^nextpowerof2
	print paddeddatasize
	redimension /N=(paddeddatasize) $wname

	//perform forward fft to convert to frequency domain
	FFT/OUT=1/DEST=FFTwave $wname
	
	variable nyquistfrequency = samplerate/2
	variable cutoffpoint = ceil(cutofffrequency/nyquistfrequency*numpnts(FFTwave))
	variable cutoffpoint2 = ceil((cutofffrequency+0.5)/nyquistfrequency*numpnts(FFTwave))
	variable origpoints = numpnts(FFTwave)
	string outputwavename
	
	//replace magnitudes with zeros where energy is to be removed from the spectrum
	if(stringmatch(filtertype,"lowpass"))
		DeletePoints cutoffpoint,origpoints-cutoffpoint, FFTwave
		InsertPoints cutoffpoint,origpoints-cutoffpoint, FFTwave
		outputwavename = wname + "-lp"
	elseif(stringmatch(filtertype,"highpass"))
		DeletePoints 0,cutoffpoint, FFTwave
		InsertPoints 0,cutoffpoint, FFTwave
		outputwavename = wname + "-hp"
	endif
	
	//perform reverse or inverse fft to convert back to time domain
	IFFT/DEST=$outputwavename FFTwave
		
	//remove padding
	redimension /N=(originaldatasize) $wname
	redimension /N=(originaldatasize) $outputwavename
	
	//add the mean of the input data file
	wave wwave2 = $outputwavename
	wwave = wwave + wmean
	wwave2 = wwave2 + wmean
		
	//display original wave and filtered wave
	Display $wname,$outputwavename
	ModifyGraph rgb($wname)=(0,12800,52224)
	Legend/C/N=text0/A=MC
	
end // fftfilter






