#pragma rtGlobals=1		// Use modern global access method.



#include "nswccd65-amplitudes"
#include "nswccd65-data"
#include "nswccd65-ddxbdfld"
#include "nswccd65-ddxfld2sd"
#include "nswccd65-ddxsternramp"
#include "nswccd65-fftfilter"
#include "nswccd65-hsv2"
#include "nswccd65-inls"
#include "nswccd65-mmm"
#include "nswccd65-psd"
#include "nswccd65-rainflow"
#include "nswccd65-rao"
#include "nswccd65-rosette"
#include "nswccd65-weibull"
#include "nswccd65-xcraftrst"


#include <Strings as Lists>
#include <Remove Points>
#include <Concatenate Waves>
//#include <Power Spectral Density>
//#include <DFTMagPhase>
//#include <FTMagPhase>
//#include <CmplxToMagPhase>
//#include <FTMagPhaseThreshold>
//#include ":IFDL Procedures:IFDL"




//functions are faster than macros
//functions can be inserted into the macros menu
//Proc procedures can use global wave names directly
//proc pcocedures are macros that do not show up in the menu by default




Menu "nswccd65igor"
	"version  200611211345"
	"-"
	"Load Generic SCL Binary Data File SP4BHBF", loadGenericSCLFileSP4BHBF("")
	Submenu "Data Set Specific Functions"
		"NSWCCD65 Load Data Sets From Folder", nswccd65LoadDataSetsFromFolder()
		Submenu "XCraft"
			"packet binary - use xcdata from Hildstrom Engineering"
			"xcraftrst50hzLoadFile", xcraftrst50hzLoadFile("",1)
			"xcraftrst50hzRenameScale", xcraftrst50hzRenameScale("wave")
			"xcraftrst100hzLoadFile", xcraftrst100hzLoadFile("",1)
			"xcraftrst100hzRenameScale", xcraftrst100hzRenameScale("wave")
			"xcraftrst200hzLoadFile", xcraftrst200hzLoadFile("",1)
			"xcraftrst200hzRenameScale", xcraftrst200hzRenameScale("wave")
			"xcraftrst2000hzLoadFile60", xcraftrst2000hzLoadFile60("",1)
			"xcraftrst2000hzRenameScale60", xcraftrst2000hzRenameScale60("wave")
			"xcraftrst2000hzLoadFile32", xcraftrst2000hzLoadFile32("",1)
			"xcraftrst2000hzRenameScale32", xcraftrst2000hzRenameScale32("wave")
		End
		Submenu "DDX FLD2 SD Model"
			"Create Sonar Dome Plots", createSonarDomePlots()
			"Create Sonar Dome Plots With Average", createSonarDomePlotsWithAP()
			"Create DDXFLD2 Fast Data Pressure Gage Animation", imageplots2()
			"Create DDXFLD2 Average Pressure Gage Time History", createaveragepressure()
			"DDXModelSDFASTLoadFile", DDXModelSDFASTLoadFile("",1)
			"DDXModelSDFASTRenameScale", DDXModelSDFASTRenameScale("wave")
			"DDXModelSDMEDIUMLoadFile", DDXModelSDMEDIUMLoadFile("",1)
			"DDXModelSDMEDIUMRenameScale", DDXModelSDMEDIUMRenameScale("wave")
			"DDXModelFLD2FASTLoadFile", DDXModelFLD2FASTLoadFile("",1)
			"DDXModelFLD2FASTRenameScale", DDXModelFLD2FASTRenameScale("wave")
			"DDXModelFLD2MEDIUMLoadFile", DDXModelFLD2MEDIUMLoadFile("",1)
			"DDXModelFLD2MEDIUMRenameScale", DDXModelFLD2MEDIUMRenameScale("wave")
			"DDXModelFLD2SLOWLoadFile", DDXModelFLD2SLOWLoadFile("",1)
			"DDXModelFLD2SLOWRenameScale", DDXModelFLD2SLOWRenameScale("wave")
		End
		Submenu "INLS"
			"INLS2LoadFile - Void1", INLS2LoadFileVoid1("",1)
			"INLS2RenameScale - Void1", INLS2RenameScaleVoid1("wave")
			"INLS2LoadFile - Void2", INLS2LoadFileVoid2("",1)
			"INLS2RenameScale - Void2", INLS2RenameScaleVoid2("wave")
			"INLS2LoadFile - Void3", INLS2LoadFileVoid3("",1)
			"INLS2RenameScale - Void3", INLS2RenameScaleVoid3("wave")
			"INLSLoadFile - 69 channels", INLSLoadFile("",1)
			"INLSRenameScale - 69 channels", INLSRenameScale("wave")
			"INLSLoadFile2 - 68 channels", INLSLoadFile2("",1)
			"INLSRenameScale2 - 68 channels", INLSRenameScale2("wave")
			"INLSLoadFile3 - 42 channels", INLSLoadFile3("",1)
			"INLSRenameScale3 - 42 channels", INLSRenameScale3("wave")
		End
		Submenu "DDX BD FLD Model"
			"DDXModelFASTLoadFile", DDXModelFASTLoadFile("",1)
			"DDXModelFASTRenameScale", DDXModelFASTRenameScale("wave")
			"DDXModelMEDIUMLoadFile", DDXModelMEDIUMLoadFile("",1)
			"DDXModelMEDIUMRenameScale", DDXModelMEDIUMRenameScale("wave")
			"DDXModelBDSLOWLoadFile", DDXModelBDSLOWLoadFile("",1)
			"DDXModelBDSLOWRenameScale", DDXModelBDSLOWRenameScale("wave")
			"DDXModelFLDSLOWLoadFile", DDXModelFLDSLOWLoadFile("",1)
			"DDXModelFLDSLOWRenameScale", DDXModelFLDSLOWRenameScale("wave")
			"DDXModelHYDROLoadFile", DDXModelHYDROLoadFile("",1)
			"DDXModelHYDRORenameScale", DDXModelHYDRORenameScale("wave")
			"BreakWaveIntoQuartersAndConcatenate", BWIQAC("")
		End
		Submenu "DDX Stern Ramp"
			"DDXSternRampLoadFile", DDXSternRampLoadFile("",1)
			"DDXSternRampRenameScale", DDXSternRampRenameScale("wave")
		End
		Submenu "Fred Olsen"
			"need data formats maybe ascii"
		End
		Submenu "HSV2"
			"HSV2FASTLoadFile", HSV2FASTLoadFile("",1)
			"HSV2FASTRenameScale", HSV2FASTRenameScale("wave")
			"HSV2slowLoadFile", HSV2slowLoadFile("",1)
			"HSV2slowRenameScale", HSV2slowRenameScale("wave")
		End
		Submenu "CRS"
			"need data formats"
		End
		Submenu "HSS"
			"need data formats"
		End
		Submenu "HSV-X1"
			"need data formats"
		End
		Submenu "DDG-51"
			"need data formats"
		End
	End

	"-"
	"Subtract Mean from Single Wave", SubtractMean("")
	"Subtract Mean from All Waves in Current Folder", SubtractMeanFromAllWaves()
	"Subtract Initial Point from Single Wave", SubtractInitial("")
	"Subtract Initial Points from All Waves in Current Folder", SubtractInitialFromAllWaves()
	"Resample Single Wave", Resample("")
	"Resample All Waves in Current Folder", ResampleAllWaves()
	"Remove Drop Outs From All Waves In Current Folder", RemoveDropOutsInCurrentFolder()
	"-"
	"FFT Filter a Single Wave - Optimal Wiener Filtering", fftfilter()
	"-"
	"Create MMM Stats Table from Current Wave Folder", GetWaveStatsInCurrentFolder(0,0)
	"-"
	"Power Spectral Density of Single Wave", PSD()
	"-"
	"Root Response Amplitude Operation of Two Waves", RAO()
	"Convert RAO From Encounter to Wave Frequency", encounter2wave()
	"-"
	"Rosette Analysis for 0, 45, 90 Rectangular Gauge", rosette()
	"-"
	"Select Rainflow Amplitudes from Single Wave", selectrainflowamplitudes()
	"-"
	"Select Amplitudes from Single Wave", selectamplitudes()
	"2 Parameter Weibull Analysis of Amplitudes", twopweibull()
	"3 Parameter Weibull Analysis of Amplitudes", threepweibull()

	Submenu "Old Weibull Analysis"
		"Initialize Program"
		"Choose To Display Or Supress Graphs"
		"Load Data Sets From Folder", LoadDataSetsFromFolder("")
		"-"
		"Do Wave Peaks, Whipping Peaks and Combined Peaks", DoWaveWhippingCombinedQuery()
		"-"
		"Do Weibull", DoWeibull(4, 0, 600,"")
		"Do All Weibull"
		"Display Weibull Results"
		"Do Lewis Weibull"
		"-"	//These are for HSV I guestt Christina wrote this for Hsv specific data
		"Choose Impact Thresholds"
		"Do All Impact and Weibull"
		"-"
		"Do Impact Peaks", DoImpactPeaksQuery()
		"Save IP results To File"
		"Impact Peaks Parameter Table"
		"-"
		"Kill Weibull Results", KillWeibull()
		help = {"This function deletes all Weibull results and sets the indexes to 0"}
	End
End//code653analysismenu



























