#pragma rtGlobals=1		// Use modern global access method.


//functions are faster than macros
//functions can be inserted into the macros menu
//Proc procedures can use global wave names directly
//proc are macros that do not show up in the menu by default


//***********************************************************************************************************************
//	Proc GetWaveStatsInCurrentFolder(t1,t2)
//		This procedure gets the wave stats over a particular range of a wave.
Function GetWaveStatsInCurrentFolder(t1,t2)
	//Variable t1=0,t2=:Duration	// This is the duration variable from the current data folder. It is the total length of the run.
	Variable t1,t2
	//Prompt t1, "Enter start point"
	//Prompt t2, "Enter end point"

	//Variable/G tbegin=t1,tend=t2
	String name = GetDataFolder(0)
	
	KillWaves /Z TheKertosis,TheSkew,tStdDev,tRange,MaxMean,MinMean,tMax,tMin,tMean,RunLength,TimeHistory

	WaveStatList (WaveList("*",";",""),name)
End
//*****End of Procedure GetWaveStatsInCurrentFolder




//***********************************************************************************************************************
//	Function WaveStatList (list,name)
// 		This is a Hack since it works on all waves in current folder
// 		Use this command ===> WaveStatList (WaveList("*", ";", ""))
Function WaveStatList(list,name)
	String list, name
	String TheWave
	Variable tbegin, tend
	Variable index=0
       
	//Create a wave to hold the respective parameters
	Make/D/O/N=100  tMean, tMin, tMax, MinMean, MaxMean, tRange, tStdDev, TheSkew, TheKertosis  
	Make/D/O/N=100 RunLength
	Make/O/T/N=100 TimeHistory
	Variable FinalCount
       
	Do
		// get the next wave name
		TheWave = GetStrFromList(list, index, ";")
      
		if (strlen(TheWave)==0)
			break
		else
          		TimeHistory[index] = TheWave
			wavestats/Q $TheWave
		
			RunLength[index] = V_npnts
			tMean[index] = V_avg
			tMin[index] = V_min
			tMax[index] = V_max
			MinMean[index] = tMin[index]-tMean[index]
			MaxMean[index] = tMax[index]-tMean[index]
			tRange[index] = tMax[index]-tMin[index]
			tStdDev[index] = V_sdev
			TheSkew[index] = V_skew
			TheKertosis[index] = V_kurt
			FinalCount = index
		endif
		index += 1
	while (1)					// as long as condition is true
     
	Redimension/N=(FinalCount+1) TimeHistory, tMean, tMin, tMax, MinMean, MaxMean, tRange, tStdDev, TheSkew, TheKertosis, RunLength
	Edit TimeHistory, tMean, tMin, tMax, MinMean, MaxMean, tRange, tStdDev, TheSkew, TheKertosis, RunLength as name
End
//*****End of Function WaveStatList

